package sortpom.wrapper;

import org.jdom.Content;
import org.jdom.Element;

/**
 * En wrapper lets its element be sorted in alphabetical order
 *
 * @author Bjorn
 */
public class AlphabeticalSortedWrapper implements Wrapper<Element> {
    private final Element element;

    public AlphabeticalSortedWrapper(final Element element) {
        this.element = element;
    }

    @Override
    public Element getContent() {
        return element;
    }

    @Override
    public boolean isBefore(final Wrapper<? extends Content> wrapper) {
        return wrapper instanceof AlphabeticalSortedWrapper
                && ((AlphabeticalSortedWrapper) wrapper).getContent().getName().compareTo(getContent().getName()) >= 0;
    }

    @Override
    public boolean isBiggerSortOrder(final Wrapper<? extends Content> wrapper) {
        if (wrapper == null) {
            return true;
        }
        if (!(wrapper instanceof AlphabeticalSortedWrapper)) {
            return false;
        }
        return ((AlphabeticalSortedWrapper) wrapper).getContent().getName().compareTo(getContent().getName()) <= 0;
    }

    @Override
    public boolean isContentElement() {
        return true;
    }

    @Override
    public boolean isResortable() {
        return true;
    }
}
